Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2934)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2938)
@@ -25,4 +25,16 @@
 ! -----------------
 ! $Id$
+! - Nesting for RANS mode implemented
+!    - Interpolation of TKE onto child domain only if both parent and child are 
+!      either in LES mode or in RANS mode
+!    - Interpolation of dissipation if both parent and child are in RANS mode
+!      and TKE-epsilon closure is applied
+!    - Enable anterpolation of TKE and dissipation rate in case parent and 
+!      child operate in RANS mode
+!
+! - Some unused variables removed from ONLY list
+! - Some formatting adjustments for particle nesting
+! 
+! 2936 2018-03-27 14:49:27Z suehring
 ! Control logics improved to allow nesting also in cases with
 ! constant_flux_layer = .F. or constant_diffusion = .T.
@@ -254,11 +266,11 @@
 #if defined( __nopointer )
     USE arrays_3d,                                                             &
-        ONLY:  dzu, dzw, e, e_p, nc, nr, pt, pt_p, q, q_p, qc, qr, s, u, u_p,  &
+        ONLY:  diss, dzu, dzw, e, e_p, nc, nr, pt, q, qc, qr, s, u, u_p,       &
                v, v_p, w, w_p, zu, zw
 #else
    USE arrays_3d,                                                              &
-        ONLY:  dzu, dzw, e, e_p, e_1, e_2, nc, nc_2, nc_p, nr, nr_2, nr_p, pt, &
-               pt_p, pt_1, pt_2, q, q_p, q_1, q_2, qc, qc_2, qr, qr_2, s, s_2, &
-               u, u_p, u_1, u_2, v, v_p, v_1, v_2, w, w_p, w_1, w_2, zu, zw
+        ONLY:  diss, diss_2, dzu, dzw, e, e_p, e_2, nc, nc_2, nc_p, nr, nr_2,  &
+               pt, pt_2, q, q_2, qc, qc_2, qr, qr_2, s, s_2,                       &
+               u, u_p, u_2, v, v_p, v_2, w, w_p, w_2, zu, zw
 #endif
 
@@ -269,6 +281,6 @@
                microphysics_morrison, microphysics_seifert,                    &
                nest_bound_l, nest_bound_r, nest_bound_s, nest_bound_n,         &
-               nest_domain, neutral, passive_scalar, roughness_length,         & 
-               simulated_time, topography, volume_flow
+               nest_domain, neutral, passive_scalar, rans_mode, rans_tke_e,    &
+               roughness_length, simulated_time, topography, volume_flow
 
     USE chem_modules,                                                          &
@@ -359,4 +371,5 @@
 
     LOGICAL, SAVE ::  nested_run = .FALSE.  !< general switch
+    LOGICAL       ::  rans_mode_parent = .FALSE. !< mode of parent model (.F. - LES mode, .T. - RANS mode)
 
     REAL(wp), SAVE ::  anterp_relax_length_l = -1.0_wp   !<
@@ -387,4 +400,5 @@
     REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_t    !<
 
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  dissc !< coarse grid array on child domain - dissipation rate
     REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ec   !<
     REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ptc  !<
@@ -401,6 +415,5 @@
     INTEGER(idp), SAVE, DIMENSION(:,:), ALLOCATABLE, TARGET, PUBLIC ::  part_adrc   !<
 
-
-    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  chem_spec_c   !< child coarse data array for chemical species 
+    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  chem_spec_c !< coarse grid array on child domain - chemical species
 
 !
@@ -616,5 +629,5 @@
            anterp_relax_length_t, child_to_parent, comm_world_nesting,         &
            cpl_id, nested_run, nesting_datatransfer_mode, nesting_mode,        &
-           parent_to_child
+           parent_to_child, rans_mode_parent
 
     PUBLIC pmci_boundary_conds
@@ -804,4 +817,5 @@
 !   Initialize the pmc parent
     CALL pmc_parentinit
+
 !
 !-- Corners of all children of the present parent
@@ -821,5 +835,6 @@
 
        child_id = pmc_parent_for_child(m)
-       IF ( myid == 0 )  THEN        
+
+       IF ( myid == 0 )  THEN
 
           CALL pmc_recv_from_child( child_id, val,  size(val),  0, 123, ierr )
@@ -932,4 +947,9 @@
           DEALLOCATE( cl_coord_x )
           DEALLOCATE( cl_coord_y )
+
+!
+!--       Send information about operating mode (LES or RANS) to child. This will be 
+!--       used to control TKE nesting and setting boundary conditions properly.
+          CALL pmc_send_to_child( child_id, rans_mode, 1, 0, 19, ierr )  
 !
 !--       Send coarse grid information to child
@@ -990,4 +1010,5 @@
           ENDIF
        ENDDO
+
        CALL pmc_s_setind_and_allocmem( child_id )
     ENDDO
@@ -1195,5 +1216,15 @@
        CALL pmc_set_dataarray_name( 'coarse', 'v'  ,'fine', 'v',  ierr )
        CALL pmc_set_dataarray_name( 'coarse', 'w'  ,'fine', 'w',  ierr )
+!
+!--    Set data array name for TKE. Please note, nesting of TKE is actually
+!--    only done if both parent and child are in LES or in RANS mode. Due to 
+!--    design of model coupler, however, data array names must be already 
+!--    available at this point.
        CALL pmc_set_dataarray_name( 'coarse', 'e'  ,'fine', 'e',  ierr )
+!
+!--    Nesting of dissipation rate only if both parent and child are in RANS
+!--    mode and TKE-epsilo closure is applied. Please so also comment for TKE
+!--    above.
+       CALL pmc_set_dataarray_name( 'coarse', 'diss'  ,'fine', 'diss',  ierr )
 
        IF ( .NOT. neutral )  THEN
@@ -1260,4 +1291,7 @@
           CALL pmc_send_to_parent( coord_x, nx + 1 + 2 * nbgp, 0, 11, ierr )
           CALL pmc_send_to_parent( coord_y, ny + 1 + 2 * nbgp, 0, 12, ierr )
+
+          CALL pmc_recv_from_parent( rans_mode_parent, 1, 0, 19, ierr )
+!
 !
 !--       Receive Coarse grid information.
@@ -1319,5 +1353,6 @@
        CALL MPI_BCAST( cg%zu, cg%nz+2,  MPI_REAL, 0, comm2d, ierr )
        CALL MPI_BCAST( cg%zw, cg%nz+2,  MPI_REAL, 0, comm2d, ierr )
-       
+       CALL MPI_BCAST( rans_mode_parent, 1, MPI_LOGICAL, 0, comm2d, ierr )
+  
 !
 !--    Find the index bounds for the nest domain in the coarse-grid index space
@@ -1357,8 +1392,11 @@
        ENDIF
 !
-!--    Define the SGS-TKE scaling factor based on the grid-spacing ratio
-       IF ( .NOT. constant_diffusion )  THEN
-          CALL pmci_init_tkefactor
-       ENDIF
+!--    Define the SGS-TKE scaling factor based on the grid-spacing ratio. Only
+!--    if both parent and child are in LES mode or in RANS mode. 
+!--    Please note, in case parent and child are in RANS mode, TKE weighting 
+!--    factor is simply one. 
+       IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.         &
+            (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.          &
+               .NOT. constant_diffusion ) )  CALL pmci_init_tkefactor
 !
 !--    Two-way coupling for general and vertical nesting.
@@ -2995,4 +3033,6 @@
 !--    energy spectrum. Near the surface, the reduction of TKE is made
 !--    smaller than further away from the surface.
+!--    Please note, in case parent and child model operate in RANS mode, 
+!--    TKE is not grid depenedent and weighting factor is one. 
 
        IMPLICIT NONE
@@ -3012,33 +3052,96 @@
        REAL(wp), PARAMETER ::  p23 = 2.0_wp/3.0_wp   !<        
 
-       IF ( nest_bound_l )  THEN
-          ALLOCATE( tkefactor_l(nzb:nzt+1,nysg:nyng) )
-          tkefactor_l = 0.0_wp
-          i = nxl - 1
-          DO  j = nysg, nyng
-             k_wall = get_topography_top_index_ji( j, i, 's' )
-
-             DO  k = k_wall + 1, nzt
-
-                kc     = kco(k) + 1
-                glsf   = ( dx * dy * dzu(k) )**p13
-                glsc   = ( cg%dx * cg%dy *cg%dzu(kc) )**p13
-                height = zu(k) - zu(k_wall)
-                fw     = EXP( -cfw * height / glsf )
-                tkefactor_l(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
-                                              ( glsf / glsc )**p23 )
+!
+       IF ( .NOT. rans_mode  .AND.  .NOT. rans_mode_parent )  THEN 
+          IF ( nest_bound_l )  THEN
+             ALLOCATE( tkefactor_l(nzb:nzt+1,nysg:nyng) )
+             tkefactor_l = 0.0_wp
+             i = nxl - 1
+             DO  j = nysg, nyng
+                k_wall = get_topography_top_index_ji( j, i, 's' )
+
+                DO  k = k_wall + 1, nzt
+                   kc     = kco(k) + 1
+                   glsf   = ( dx * dy * dzu(k) )**p13
+                   glsc   = ( cg%dx * cg%dy *cg%dzu(kc) )**p13
+                   height = zu(k) - zu(k_wall)
+                   fw     = EXP( -cfw * height / glsf )
+                   tkefactor_l(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
+                                                 ( glsf / glsc )**p23 )
+                ENDDO
+                tkefactor_l(k_wall,j) = c_tkef * fw0
              ENDDO
-             tkefactor_l(k_wall,j) = c_tkef * fw0
-          ENDDO
-       ENDIF
-
-       IF ( nest_bound_r )  THEN
-          ALLOCATE( tkefactor_r(nzb:nzt+1,nysg:nyng) )
-          tkefactor_r = 0.0_wp
-          i = nxr + 1
-          DO  j = nysg, nyng
-             k_wall = get_topography_top_index_ji( j, i, 's' )
-
-             DO  k = k_wall + 1, nzt
+          ENDIF
+
+          IF ( nest_bound_r )  THEN
+             ALLOCATE( tkefactor_r(nzb:nzt+1,nysg:nyng) )
+             tkefactor_r = 0.0_wp
+             i = nxr + 1
+             DO  j = nysg, nyng
+                k_wall = get_topography_top_index_ji( j, i, 's' )
+
+                DO  k = k_wall + 1, nzt
+                   kc     = kco(k) + 1
+                   glsf   = ( dx * dy * dzu(k) )**p13
+                   glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
+                   height = zu(k) - zu(k_wall)
+                   fw     = EXP( -cfw * height / glsf )
+                   tkefactor_r(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
+                                                 ( glsf / glsc )**p23 )
+                ENDDO
+                tkefactor_r(k_wall,j) = c_tkef * fw0
+             ENDDO
+          ENDIF
+
+          IF ( nest_bound_s )  THEN
+             ALLOCATE( tkefactor_s(nzb:nzt+1,nxlg:nxrg) )
+             tkefactor_s = 0.0_wp
+             j = nys - 1
+             DO  i = nxlg, nxrg
+                k_wall = get_topography_top_index_ji( j, i, 's' )
+                
+                DO  k = k_wall + 1, nzt
+    
+                   kc     = kco(k) + 1
+                   glsf   = ( dx * dy * dzu(k) )**p13
+                   glsc   = ( cg%dx * cg%dy * cg%dzu(kc) ) ** p13
+                   height = zu(k) - zu(k_wall)
+                   fw     = EXP( -cfw*height / glsf )
+                   tkefactor_s(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
+                        ( glsf / glsc )**p23 )
+                ENDDO
+                tkefactor_s(k_wall,i) = c_tkef * fw0
+             ENDDO
+          ENDIF
+
+          IF ( nest_bound_n )  THEN
+             ALLOCATE( tkefactor_n(nzb:nzt+1,nxlg:nxrg) )
+             tkefactor_n = 0.0_wp
+             j = nyn + 1
+             DO  i = nxlg, nxrg
+                k_wall = get_topography_top_index_ji( j, i, 's' )
+
+                DO  k = k_wall + 1, nzt
+
+                   kc     = kco(k) + 1
+                   glsf   = ( dx * dy * dzu(k) )**p13
+                   glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
+                   height = zu(k) - zu(k_wall)
+                   fw     = EXP( -cfw * height / glsf )
+                   tkefactor_n(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
+                                                 ( glsf / glsc )**p23 )
+                ENDDO
+                tkefactor_n(k_wall,i) = c_tkef * fw0
+             ENDDO
+          ENDIF
+
+          ALLOCATE( tkefactor_t(nysg:nyng,nxlg:nxrg) )
+          k = nzt
+
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
+!
+!--             Determine vertical index for local topography top
+                k_wall = get_topography_top_index_ji( j, i, 's' )
 
                 kc     = kco(k) + 1
@@ -3047,71 +3150,32 @@
                 height = zu(k) - zu(k_wall)
                 fw     = EXP( -cfw * height / glsf )
-                tkefactor_r(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
+                tkefactor_t(j,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *        &
                                               ( glsf / glsc )**p23 )
              ENDDO
-             tkefactor_r(k_wall,j) = c_tkef * fw0
           ENDDO
-       ENDIF
-
-       IF ( nest_bound_s )  THEN
-          ALLOCATE( tkefactor_s(nzb:nzt+1,nxlg:nxrg) )
-          tkefactor_s = 0.0_wp
-          j = nys - 1
-          DO  i = nxlg, nxrg
-             k_wall = get_topography_top_index_ji( j, i, 's' )
-             
-             DO  k = k_wall + 1, nzt
- 
-                kc     = kco(k) + 1
-                glsf   = ( dx * dy * dzu(k) )**p13
-                glsc   = ( cg%dx * cg%dy * cg%dzu(kc) ) ** p13
-                height = zu(k) - zu(k_wall)
-                fw     = EXP( -cfw*height / glsf )
-                tkefactor_s(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
-                     ( glsf / glsc )**p23 )
-             ENDDO
-             tkefactor_s(k_wall,i) = c_tkef * fw0
-          ENDDO
-       ENDIF
-
-       IF ( nest_bound_n )  THEN
-          ALLOCATE( tkefactor_n(nzb:nzt+1,nxlg:nxrg) )
-          tkefactor_n = 0.0_wp
-          j = nyn + 1
-          DO  i = nxlg, nxrg
-             k_wall = get_topography_top_index_ji( j, i, 's' )
-
-             DO  k = k_wall + 1, nzt
-
-                kc     = kco(k) + 1
-                glsf   = ( dx * dy * dzu(k) )**p13
-                glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
-                height = zu(k) - zu(k_wall)
-                fw     = EXP( -cfw * height / glsf )
-                tkefactor_n(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
-                                              ( glsf / glsc )**p23 )
-             ENDDO
-             tkefactor_n(k_wall,i) = c_tkef * fw0
-          ENDDO
-       ENDIF
-
-       ALLOCATE( tkefactor_t(nysg:nyng,nxlg:nxrg) )
-       k = nzt
-
-       DO  i = nxlg, nxrg
-          DO  j = nysg, nyng
-!
-!--          Determine vertical index for local topography top
-             k_wall = get_topography_top_index_ji( j, i, 's' )
-
-             kc     = kco(k) + 1
-             glsf   = ( dx * dy * dzu(k) )**p13
-             glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
-             height = zu(k) - zu(k_wall)
-             fw     = EXP( -cfw * height / glsf )
-             tkefactor_t(j,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *        &
-                                           ( glsf / glsc )**p23 )
-          ENDDO
-       ENDDO
+!
+!--    RANS mode
+       ELSE
+          IF ( nest_bound_l )  THEN
+             ALLOCATE( tkefactor_l(nzb:nzt+1,nysg:nyng) )
+             tkefactor_l = 1.0_wp
+          ENDIF
+          IF ( nest_bound_r )  THEN
+             ALLOCATE( tkefactor_r(nzb:nzt+1,nysg:nyng) )
+             tkefactor_r = 1.0_wp
+          ENDIF
+          IF ( nest_bound_s )  THEN
+             ALLOCATE( tkefactor_s(nzb:nzt+1,nxlg:nxrg) )
+             tkefactor_s = 1.0_wp
+          ENDIF
+          IF ( nest_bound_n )  THEN
+             ALLOCATE( tkefactor_n(nzb:nzt+1,nxlg:nxrg) )
+             tkefactor_n = 1.0_wp
+          ENDIF
+
+          ALLOCATE( tkefactor_t(nysg:nyng,nxlg:nxrg) )
+          tkefactor_t = 1.0_wp
+
+       ENDIF
       
     END SUBROUTINE pmci_init_tkefactor
@@ -3177,17 +3241,18 @@
 !-- List of array names, which can be coupled.
 !-- In case of 3D please change also the second array for the pointer version
-    IF ( TRIM(name) == "u"  )  p_3d => u
-    IF ( TRIM(name) == "v"  )  p_3d => v
-    IF ( TRIM(name) == "w"  )  p_3d => w
-    IF ( TRIM(name) == "e"  )  p_3d => e
-    IF ( TRIM(name) == "pt" )  p_3d => pt
-    IF ( TRIM(name) == "q"  )  p_3d => q
-    IF ( TRIM(name) == "qc" )  p_3d => qc
-    IF ( TRIM(name) == "qr" )  p_3d => qr
-    IF ( TRIM(name) == "nr" )  p_3d => nr
-    IF ( TRIM(name) == "nc" )  p_3d => nc
-    IF ( TRIM(name) == "s"  )  p_3d => s
-    IF ( TRIM(name) == "nr_part"  )   i_2d => nr_part
-    IF ( TRIM(name) == "part_adr"  )  i_2d => part_adr
+    IF ( TRIM(name) == "u"          )  p_3d => u
+    IF ( TRIM(name) == "v"          )  p_3d => v
+    IF ( TRIM(name) == "w"          )  p_3d => w
+    IF ( TRIM(name) == "e"          )  p_3d => e
+    IF ( TRIM(name) == "pt"         )  p_3d => pt
+    IF ( TRIM(name) == "q"          )  p_3d => q
+    IF ( TRIM(name) == "qc"         )  p_3d => qc
+    IF ( TRIM(name) == "qr"         )  p_3d => qr
+    IF ( TRIM(name) == "nr"         )  p_3d => nr
+    IF ( TRIM(name) == "nc"         )  p_3d => nc
+    IF ( TRIM(name) == "s"          )  p_3d => s
+    IF ( TRIM(name) == "diss"       )  p_3d => diss   
+    IF ( TRIM(name) == "nr_part"    )   i_2d => nr_part
+    IF ( TRIM(name) == "part_adr"   )  i_2d => part_adr
     IF ( INDEX( TRIM(name), "chem_" ) /= 0 )  p_3d => chem_species(n)%conc
 
@@ -3219,15 +3284,16 @@
     ENDIF
 #else
-    IF ( TRIM(name) == "u"  )  p_3d_sec => u_2
-    IF ( TRIM(name) == "v"  )  p_3d_sec => v_2
-    IF ( TRIM(name) == "w"  )  p_3d_sec => w_2
-    IF ( TRIM(name) == "e"  )  p_3d_sec => e_2
-    IF ( TRIM(name) == "pt" )  p_3d_sec => pt_2
-    IF ( TRIM(name) == "q"  )  p_3d_sec => q_2
-    IF ( TRIM(name) == "qc" )  p_3d_sec => qc_2
-    IF ( TRIM(name) == "qr" )  p_3d_sec => qr_2
-    IF ( TRIM(name) == "nr" )  p_3d_sec => nr_2
-    IF ( TRIM(name) == "nc" )  p_3d_sec => nc_2
-    IF ( TRIM(name) == "s"  )  p_3d_sec => s_2
+    IF ( TRIM(name) == "u"    )  p_3d_sec => u_2
+    IF ( TRIM(name) == "v"    )  p_3d_sec => v_2
+    IF ( TRIM(name) == "w"    )  p_3d_sec => w_2
+    IF ( TRIM(name) == "e"    )  p_3d_sec => e_2
+    IF ( TRIM(name) == "pt"   )  p_3d_sec => pt_2
+    IF ( TRIM(name) == "q"    )  p_3d_sec => q_2
+    IF ( TRIM(name) == "qc"   )  p_3d_sec => qc_2
+    IF ( TRIM(name) == "qr"   )  p_3d_sec => qr_2
+    IF ( TRIM(name) == "nr"   )  p_3d_sec => nr_2
+    IF ( TRIM(name) == "nc"   )  p_3d_sec => nc_2
+    IF ( TRIM(name) == "s"    )  p_3d_sec => s_2
+    IF ( TRIM(name) == "diss" )  p_3d_sec => diss_2
     IF ( INDEX( TRIM(name), "chem_" ) /= 0 )  p_3d_sec => spec_conc_2(:,:,:,n)
 
@@ -3358,4 +3424,7 @@
        IF ( .NOT. ALLOCATED( ec ) )  ALLOCATE( ec(0:nzc+1,js:je,is:ie) )
        p_3d => ec
+    ELSEIF ( TRIM( name ) == "diss" )  THEN
+       IF ( .NOT. ALLOCATED( dissc ) )  ALLOCATE( dissc(0:nzc+1,js:je,is:ie) )
+       p_3d => dissc
     ELSEIF ( TRIM( name ) == "pt")  THEN
        IF ( .NOT. ALLOCATED( ptc ) )  ALLOCATE( ptc(0:nzc+1,js:je,is:ie) )
@@ -3379,9 +3448,9 @@
        IF ( .NOT. ALLOCATED( sc ) )  ALLOCATE( sc(0:nzc+1,js:je,is:ie) )
        p_3d => sc
-    ELSEIF (trim(name) == "nr_part") then
-       IF (.not.allocated(nr_partc))  allocate(nr_partc(js:je, is:ie))
+    ELSEIF ( TRIM( name ) == "nr_part") THEN
+       IF ( .NOT. ALLOCATED( nr_partc ) )  ALLOCATE( nr_partc(js:je,is:ie) )
        i_2d => nr_partc
-    ELSEIF (trim(name) == "part_adr") then
-       IF (.not.allocated(part_adrc))  allocate(part_adrc(js:je, is:ie))
+    ELSEIF ( TRIM( name ) == "part_adr") THEN
+       IF ( .NOT. ALLOCATED( part_adrc ) )  ALLOCATE( part_adrc(js:je,is:ie) )
        i_2d => part_adrc
     ELSEIF ( TRIM( name(1:5) ) == "chem_" )  THEN
@@ -3484,9 +3553,16 @@
                                    r2yo, r1zw, r2zw, 'w' )
 
-       IF ( .NOT. constant_diffusion )  THEN
-          CALL pmci_interp_tril_all ( e,  ec,  ico, jco, kco, r1xo, r2xo,      &
-                                      r1yo, r2yo, r1zo, r2zo, 'e' )
-       ENDIF
-       
+       IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.          &
+            (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.           &
+               .NOT. constant_diffusion ) )  THEN
+          CALL pmci_interp_tril_all ( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, &
+                                      r2yo, r1zo, r2zo, 'e' )
+       ENDIF
+
+       IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
+          CALL pmci_interp_tril_all ( diss,  dissc,  ico, jco, kco, r1xo, r2xo,&
+                                      r1yo, r2yo, r1zo, r2zo, 's' )
+       ENDIF
+
        IF ( .NOT. neutral )  THEN
           CALL pmci_interp_tril_all ( pt, ptc, ico, jco, kco, r1xo, r2xo,      &
@@ -4207,5 +4283,7 @@
                                        nzt_topo_nestbc_l, 'l', 'w' )
 
-             IF ( .NOT. constant_diffusion )  THEN
+             IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.   &
+                  (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.    &
+                     .NOT. constant_diffusion ) )  THEN
                 CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
                                           r1yo, r2yo, r1zo, r2zo,              &
@@ -4214,5 +4292,13 @@
                                           nzt_topo_nestbc_l, 'l', 'e' )
              ENDIF
-             
+
+             IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
+                CALL pmci_interp_tril_lr( diss,  dissc,  ico, jco, kco, r1xo,  &
+                                          r2xo, r1yo, r2yo, r1zo, r2zo,        &
+                                          logc_w_l, logc_ratio_w_l,            &
+                                          logc_kbounds_w_l,                    &
+                                          nzt_topo_nestbc_l, 'l', 's' )
+             ENDIF
+
              IF ( .NOT. neutral )  THEN
                 CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
@@ -4304,5 +4390,7 @@
                                        nzt_topo_nestbc_r, 'r', 'w' )
 
-             IF ( .NOT. constant_diffusion )  THEN
+             IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.   &
+                  (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.    &
+                     .NOT. constant_diffusion ) )  THEN
                 CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
                                           r1yo,r2yo, r1zo, r2zo,               &
@@ -4310,4 +4398,14 @@
                                           logc_kbounds_w_r,                    &
                                           nzt_topo_nestbc_r, 'r', 'e' )
+
+             ENDIF
+
+             IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
+                CALL pmci_interp_tril_lr( diss,  dissc,  ico, jco, kco, r1xo,  &
+                                          r2xo, r1yo,r2yo, r1zo, r2zo,         &
+                                          logc_w_r, logc_ratio_w_r,            &
+                                          logc_kbounds_w_r,                    &
+                                          nzt_topo_nestbc_r, 'r', 's' )
+
              ENDIF
 
@@ -4382,5 +4480,4 @@
                 ENDDO
              ENDIF
-
           ENDIF
 !
@@ -4406,5 +4503,7 @@
                                        nzt_topo_nestbc_s, 's','w' )
 
-             IF ( .NOT. constant_diffusion )  THEN
+             IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.   &
+                  (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.    &
+                     .NOT. constant_diffusion ) )  THEN
                 CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
                                           r1yo, r2yo, r1zo, r2zo,              &
@@ -4412,6 +4511,16 @@
                                           logc_kbounds_w_s,                    &
                                           nzt_topo_nestbc_s, 's', 'e' )
+
              ENDIF
-          
+
+             IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
+                CALL pmci_interp_tril_sn( diss, dissc,  ico, jco, kco, r1xo,   &
+                                          r2xo, r1yo, r2yo, r1zo, r2zo,        &
+                                          logc_w_s, logc_ratio_w_s,            &
+                                          logc_kbounds_w_s,                    &
+                                          nzt_topo_nestbc_s, 's', 's' )
+
+             ENDIF
+
              IF ( .NOT. neutral )  THEN
                 CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
@@ -4482,5 +4591,4 @@
                 ENDDO
              ENDIF
-
           ENDIF
 !
@@ -4505,5 +4613,8 @@
                                        logc_kbounds_w_n,                       &
                                        nzt_topo_nestbc_n, 'n', 'w' )
-             IF ( .NOT. constant_diffusion )  THEN
+
+             IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.   & 
+                  (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.    &
+                     .NOT. constant_diffusion ) )  THEN
                 CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
                                           r1yo, r2yo, r1zo, r2zo,              &
@@ -4511,6 +4622,16 @@
                                           logc_kbounds_w_n,                    &
                                           nzt_topo_nestbc_n, 'n', 'e' )
+
              ENDIF
-          
+
+             IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
+                CALL pmci_interp_tril_sn( diss, dissc,  ico, jco, kco, r1xo,   &
+                                          r2xo, r1yo, r2yo, r1zo, r2zo,        &
+                                          logc_w_n, logc_ratio_w_n,            &
+                                          logc_kbounds_w_n,                    &
+                                          nzt_topo_nestbc_n, 'n', 's' )
+
+             ENDIF
+
              IF ( .NOT. neutral )  THEN
                 CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
@@ -4581,5 +4702,4 @@
                 ENDDO
              ENDIF
-             
           ENDIF
 
@@ -4593,8 +4713,17 @@
        CALL pmci_interp_tril_t( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,      &
                                 r2yo, r1zw, r2zw, 'w' )
-       IF ( .NOT. constant_diffusion )  THEN
+
+       IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.         &
+            (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.          &
+               .NOT. constant_diffusion ) )  THEN
           CALL pmci_interp_tril_t( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,   &
                                    r2yo, r1zo, r2zo, 'e' )
        ENDIF
+
+       IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
+          CALL pmci_interp_tril_t( diss, dissc, ico, jco, kco, r1xo, r2xo,     &
+                                   r1yo, r2yo, r1zo, r2zo, 's' )
+       ENDIF
+
        IF ( .NOT. neutral )  THEN
           CALL pmci_interp_tril_t( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo,   &
@@ -4644,5 +4773,5 @@
           ENDDO
        ENDIF
-    
+
    END SUBROUTINE pmci_interpolation
 
@@ -4666,4 +4795,18 @@
       CALL pmci_anterp_tophat( w,  wc,  kctw, iflo, ifuo, jflo, jfuo, kflw,    &
                                kfuw, ijfc_s, kfc_w, 'w' )
+!
+!--   Anterpolation of TKE and dissipation rate if parent and child are in 
+!--   RANS mode.
+      IF ( rans_mode_parent  .AND.  rans_mode )  THEN
+         CALL pmci_anterp_tophat( e, ec, kctu, iflo, ifuo, jflo, jfuo, kflo,   &
+                                  kfuo, ijfc_s, kfc_s, 'e' )
+!
+!--      Anterpolation of dissipation rate only if TKE-e closure is applied.
+         IF ( rans_tke_e )  THEN
+            CALL pmci_anterp_tophat( diss, dissc, kctu, iflo, ifuo, jflo, jfuo,&
+                                     kflo, kfuo, ijfc_s, kfc_s, 'diss' )
+         ENDIF
+
+      ENDIF
 
       IF ( .NOT. neutral )  THEN
@@ -5569,3 +5712,4 @@
  END SUBROUTINE pmci_boundary_conds
 
+
 END MODULE pmc_interface
Index: palm/trunk/SOURCE/pmc_mpi_wrapper_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_mpi_wrapper_mod.f90	(revision 2934)
+++ palm/trunk/SOURCE/pmc_mpi_wrapper_mod.f90	(revision 2938)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Extent interface by logical buffer 
+! 
+! 2936 2018-03-27 14:49:27Z suehring
 ! Bugfix: wrong placement of include 'mpif.h' corrected
 ! 
@@ -103,4 +106,5 @@
 
     INTERFACE pmc_recv_from_parent
+       MODULE PROCEDURE pmc_recv_from_parent_logical
        MODULE PROCEDURE pmc_recv_from_parent_integer
        MODULE PROCEDURE pmc_recv_from_parent_real_r1
@@ -110,4 +114,5 @@
 
     INTERFACE pmc_send_to_child
+       MODULE PROCEDURE pmc_send_to_child_logical
        MODULE PROCEDURE pmc_send_to_child_integer
        MODULE PROCEDURE pmc_send_to_child_real_r1
@@ -149,4 +154,41 @@
 
 
+ SUBROUTINE pmc_recv_from_parent_logical( buf, n, parent_rank, tag, ierr )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                ::  n            !<
+    INTEGER, INTENT(IN)                ::  parent_rank  !<
+    INTEGER, INTENT(IN)                ::  tag          !<
+    INTEGER, INTENT(OUT)               ::  ierr         !<
+
+    LOGICAL, INTENT(OUT)               ::  buf          !<
+    
+    ierr = 0
+    CALL MPI_RECV( buf, n, MPI_LOGICAL, parent_rank, tag, m_to_parent_comm,    &
+                   MPI_STATUS_IGNORE, ierr )
+
+ END SUBROUTINE pmc_recv_from_parent_logical
+
+ SUBROUTINE pmc_send_to_child_logical( child_id, buf, n, child_rank, tag,      &
+                                       ierr )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)               ::  child_id     !<
+    INTEGER, INTENT(IN)               ::  n            !<
+    INTEGER, INTENT(IN)               ::  child_rank   !<
+    INTEGER, INTENT(IN)               ::  tag          !<
+    INTEGER, INTENT(OUT)              ::  ierr         !<
+
+    LOGICAL, INTENT(IN)               ::  buf          !<
+   
+    ierr = 0
+    CALL MPI_SEND( buf, n, MPI_LOGICAL, child_rank, tag,                       &
+                   m_to_child_comm(child_id), ierr )
+
+ END SUBROUTINE pmc_send_to_child_logical
+
+
  SUBROUTINE pmc_send_to_parent_integer( buf, n, parent_rank, tag, ierr )
 
@@ -167,5 +209,4 @@
 
 
-
  SUBROUTINE pmc_recv_from_parent_integer( buf, n, parent_rank, tag, ierr )
 
@@ -312,5 +353,4 @@
 
  END SUBROUTINE pmc_recv_from_parent_real_r3
-
 
 
